module TypeGeometry
# include "allocate.h"
  use accuracy
  implicit none

  private
  
  !!* Type for containing geometrical information
  type TGeometry
    integer           :: nAtom
    logical           :: tPeriodic
    logical           :: tFracCoord
    integer,  pointer :: species(:)  => null()
    real(dp), pointer :: coords(:,:) => null()
    integer           :: nSpecie
    real(dp), pointer :: origin(:) => null()
    real(dp), pointer :: latVecs(:,:) => null()
    real(dp), pointer :: recVecs2p(:,:) => null()
    character(mc), pointer :: specieNames(:) => null()
  end type TGeometry

  !!* Interface for destroying a TGeometry type
  interface destruct
    module procedure destruct_Geometry
  end interface

  public :: TGeometry, destruct

contains

  !!* Destroys the TGeometry object
  !!* @param self Geometry object
  subroutine destruct_Geometry(self)
    type(TGeometry), intent(inout) :: self

    DEALLOCATE_PARR(self%species)
    DEALLOCATE_PARR(self%coords)
    DEALLOCATE_PARR(self%origin)
    DEALLOCATE_PARR(self%latVecs)
    DEALLOCATE_PARR(self%recVecs2p)
    DEALLOCATE_PARR(self%specieNames)
    
  end subroutine destruct_Geometry



end module TypeGeometry
